<template>
  <div class="container">
    <form class="text-md-center" v-if="!$store.state.auth" @submit.prevent="login" >
      <p v-if="formError" class="error">{{ formError }}</p>
        <v-text-field v-model="formUsername" :rules="[rules.required]" label="Username" outline></v-text-field>
      <!-- <p>Username: <input v-model="formUsername" type="text" name="username"></p> -->
      <!-- <p>Password: <input v-model="formPassword" type="password" name="password"></p> -->
        <v-text-field v-model="formPassword" :rules="[rules.required]" type='password' label="Password" outline></v-text-field>
      <!-- <button type="submit">Login</button> -->
      <v-btn xs4 color="primary" type="submit">Login</v-btn>
    </form>
    <div v-else>
      Welcome, {{ $store.state.auth.username }}
      <v-btn xs4 color="primary" @click="logout">Logout</v-btn>
    </div>
  </div>
</template>

<script>
  export default {
    data() {
      return {
        formError: null,
        formUsername: '',
        formPassword: '',
        rules: {
            required: value => !!value || 'Required.'
        }
      }
    },
    created(){
      this.initialize();
    },
    methods: {
      initialize() {
       this.$store.dispatch('init');
      },
      logout() {
        if (window.localStorage) {
          localStorage.removeItem('auth');
          this.$router.go()
        }
      },
      async login() {
        try {
          await this.$store.dispatch('login', {
            username: this.formUsername,
            password: this.formPassword
          })
          this.formUsername = ''
          this.formPassword = ''
          this.formError = null
        } catch (e) {
          this.formError = e.message
        }
      }
    }
  }

</script>

<style>
  .container {
    padding: 100px;
  }

  .error {
    color: red;
  }

</style>
